#!/usr/bin/python3

from subprocess import Popen, PIPE
from os.path import abspath, dirname, join
from sys import argv, stderr

from testlist import TESTS

TIMEOUT=60

def main(se):
    total, failed, timeouted = 0, 0, 0
    for program, nop, noe in TESTS:
        total += 1
        cmd = ['timeout', str(TIMEOUT), 'python3', abspath(se), abspath(join(dirname(argv[0]), program))]
        #cmd = ['timeout', str(TIMEOUT), abspath(se), abspath(join(dirname(argv[0]), program))]
        print('Running: ', " ".join(cmd))
        P = Popen(cmd, stdout=PIPE, stderr=PIPE)
        out, err = P.communicate()
        if out is None:
            print(f"{program}... failed")
            failed += 1
            continue

        nopstr = f"Executed paths: {nop}"
        noestr = f"Error paths: {noe}"

        have_nopstr = False
        have_noestr = False
        for line in (l.strip().decode('utf-8') for l in out.splitlines()):
            if line == nopstr:
                have_nopstr = True
            elif line == noestr:
                have_noestr = True

        if not have_nopstr or not have_noestr:
            retval = P.poll()
            if retval == 124:
                print(f"{program}... timeout")
                timeouted += 1
            else:
                print(f"{program}... failed ({retval})")
            failed += 1
        else:
            print(f"{program}... ok")

    print(f"From {total} tests, {failed} failed ({timeouted} timeouted)")

if __name__ == "__main__":
    if len(argv) != 2:
        print(f"Usage: {argv[0]} <symbolic-executor>", file=stderr)
        exit(1)

    main(argv[1])
